// logip.cpp

#include	"logip.h"
#include	"logipdat.h"

#define	VER	"logip ver.0.02"

main()
{
	logip*	app;
	app=new logip();
	app->Run();
	delete app;
	return(true);
}
//------------------------------------------------
logip::logip():BApplication("application/x-vnd.Beer-logip")
{
	BRect	frame(100,100,300,220);
	w=new logipwindow(frame);
}

void logip::RefsReceived(BMessage *mes)
{
	uint32	type;
	int32	files;
	mes->GetInfo("refs",&type,&files);
	if(files>0){
		entry_ref	eref;
		BMessage msg(B_SIMPLE_DATA);
		for(int i=0;i<files;i++){
			mes->FindRef("refs",i,&eref);
			msg.AddRef("refs",&eref);
		}
		w->PostMessage(&msg,w->v);
	}
}

void logip::MessageReceived(BMessage *mes)
{
	switch(mes->what){
		case B_SAVE_REQUESTED:{
			entry_ref	dir;
			char		*name;
			mes->FindRef("directory",&dir);
			mes->FindString("name",&name);
			BMessage msg(B_SAVE_REQUESTED);
			msg.AddRef("directory",&dir);
			msg.AddString("name",name);
			w->PostMessage(&msg,w->v);
		}break;
		case B_CANCEL:{
			w->PostMessage(B_CANCEL,w->v);
		}break;
		default:{
			BApplication::MessageReceived(mes);
		}break;
	}
}

void logip::AboutRequested()
{ 
	BAlert *alert;
	alert=new BAlert("",
		"logip ver.0.02   1999. 2. 9\n"
		"    copyright Hiroyuki Tsutsumi\n\n"
		" E-mail : hirotsu@blue.plala.or.jp\n"
		"   HP   : http://www1.plala.or.jp/hirotsu/"
	,"Thank you");
	alert->Go();
} 
//------------------------------------------------
logipwindow::logipwindow(BRect frame):BWindow(frame,VER,B_TITLED_WINDOW,0)
{
	BRect	viewframe;
	viewframe.Set(0,0,frame.Width(),frame.Height()-20);
	viewframe.OffsetTo(0,20);
	v=new logipview(viewframe);
	AddChild(v);
	setupmenus();
	Show();
	SetPulseRate(200000);
}

bool logipwindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}

void logipwindow::setupmenus()
{
	BMenuBar	*mb;
	BMenu		*m,*mm;
	BMenuItem	*mi;
	BMessage	*mes;
	mb=new BMenuBar(BRect(0,0,20,20),"menubar");
	m=new BMenu("File");
	 mi=new BMenuItem("open",new BMessage('fiop'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem("close",new BMessage('ficl'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem("select",new BMessage('fise'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem("save",new BMessage('fisa'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 m->AddSeparatorItem();				//editable
	 mi=new BMenuItem("new",new BMessage('fine'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem("save as",new BMessage('finw'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem("add",new BMessage('edad'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem("delete",new BMessage('edde'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 m->AddSeparatorItem();
	 mi=new BMenuItem("about",new BMessage(B_ABOUT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	 mi=new BMenuItem("quit",new BMessage(B_QUIT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	mb->AddItem(m);
	m=new BMenu("Mode");
	 mi=new BMenuItem("play",new BMessage('edpl'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem("edit",new BMessage('edep'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	mb->AddItem(m);
	AddChild(mb);
}
//------------------------------------------------
logipview::logipview(BRect frame):BView(frame,"logipview",0,B_WILL_DRAW|B_PULSE_NEEDED)
{
	fp=NULL;
	db=NULL;
	dbl=0;
	titles=0;
	bm=NULL;
	bd=NULL;
	job=0;
	ef=0;
	ed_w=ed_h=10;
	kin=know=0;
}

logipview::~logipview()
{
	rec.write_rec();
	wrk.write_wrk();
}

void logipview::AttachedToWindow()
{
	SetViewColor(0,0,0);
	SetFont(be_bold_font);
	MakeFocus();
}

void logipview::Draw(BRect rect)
{
	if(job<0){
		SetFontSize(16);
		int	vw=db?StringWidth(db+16)*1.2:0;
		int	vh=titles*20+35;
		if(vw<200)vw=200;
		if(vh<120)vh=120;
		ResizeTo(vw,vh);
		Window()->SetSizeLimits(50,vw,50,vh+20);
		Window()->ResizeTo(vw,vh+20);
		job=-job;
	}
	if(job==0){
		ResizeTo(200,120);
		Window()->SetSizeLimits(50,200,50,120+20);
		Window()->ResizeTo(200,120+20);
		SetHighColor(255,255,255);	SetLowColor(200,200,200);
		SetFontSize(30);
		DrawString("Logip",BPoint(50,50));
		SetFontSize(20);
		DrawString("ver.0.02",BPoint(75,80));
	}
	if(job==1){
		SetFontSize(16);
		char	*p=db+64;
		SetHighColor(255,200,200);	SetLowColor(200,150,150);
		DrawString(db+16,BPoint(3,25));
		SetHighColor(200,255,255);	SetLowColor(150,200,200);
		for(int i=0;i<titles;i++){
			DrawString(p+2,BPoint(5,i*20+50));
			if(rec.get_rec(fn,i)=='o')StrokeLine(BPoint(0,i*20+45),BPoint(200,i*20+45));
			if(i==no)InvertRect(BRect(0,i*20+35,200,i*20+55));
			p+=(*p)*256+*((uchar*)p+1);
		}
	}
	if(job==2){
		DrawBitmap(bm,rect,rect);
	}
}

void logipview::Pulse()
{
	if(job!=3)return;
	DrawBitmap(bm,BPoint(0,0));
	SetHighColor(255,0,0);	SetLowColor(200,0,0);
	SetFontSize(40);
	DrawString("Complete",BPoint(tm,50));
	tm=(tm+StringWidth("Complete")<0)?bm->Bounds().Width():tm-10;
}

void logipview::MouseDown(BPoint pt)
{
	int32	mt;
	get_mouse_type(&mt);
	int		mf;
	mf=0;
	if(mt>2){
		BPoint	mp;
		uint32	mb;
		GetMouse(&mp,&mb);
		mf=(mb<3)?mb:3;
	}else{
		uint32	mk;
		mk=modifiers();
		if((mk&B_SHIFT_KEY)&&(!(mk&B_CONTROL_KEY)))mf=1;
		if((!(mk&B_SHIFT_KEY))&&(mk&B_CONTROL_KEY))mf=2;
		if((mk&B_SHIFT_KEY)&&(mk&B_CONTROL_KEY))mf=3;
	}

	if((job==2)&&(bm->Bounds().Contains(pt))){
		int	x=pt.x-0;
		int	y=pt.y-0;
		char	f=bm->bm_to_mat(x,y);
		if(f>0){			//click picture
			if(ef==0){
				bd->change_box(x,y,mf-1);
				if(bd->chk_ans())gameend();
			}
			if(ef==1){
				if(mf==0)mf=-1;
				bd->change_box(x,y,mf-1);
				bd->set_hnt(false);
			}
			bm->redraw_box(x,y);
			bm->redraw_hints(x,y);
			redraw();
		}
	}
	if((job==1)&&(no>=0))gamestart();
}

void logipview::MouseMoved(BPoint pt,uint32 code,const BMessage *msg)
{
	if(job!=1)return;
	int	n=-1;
	if((Bounds().Contains(pt))&&(pt.y>35)&&(pt.y<titles*20+35))n=(pt.y-35)/20;
	if(n!=no){
		no=n;
		Invalidate();
	}
}

void logipview::KeyDown(const char *bytes,int32 numBytes)
{
	if(job!=2)return;
	if(ef==0)return;
	if(know)return;
	if(numBytes==1){
		if((*bytes=='8')||(*bytes==B_UP_ARROW))know|=0x01;		//height-1
		if((*bytes=='2')||(*bytes==B_DOWN_ARROW))know|=0x02;	//height+1
		if((*bytes=='4')||(*bytes==B_LEFT_ARROW))know|=0x04;	//width-1
		if((*bytes=='6')||(*bytes==B_RIGHT_ARROW))know|=0x08;	//width+1
		if(know)kin=know;
	}
	
	if(kin){
		width=bd->w;
		height=bd->h;
		bool	f=false;
		if((kin==0x01)&&(height>5)){height--;f=true;}		//min=5
		if((kin==0x02)&&(height<50)){height++;f=true;}		//max=50
		if((kin==0x04)&&(width>5)){width--;f=true;}		//min=5
		if((kin==0x08)&&(width<50)){width++;f=true;}		//max=50
		if(f){
			bd->resize(width,height);
			delete	bm;
			bm=new logipbitmap(bd);
			ResizeTo(bm->Bounds().Width(),bm->Bounds().Height());
			Window()->SetSizeLimits(50,bm->Bounds().Width(),50,bm->Bounds().Height()+20);
			Window()->ResizeTo(bm->Bounds().Width(),bm->Bounds().Height()+20);
			Draw(Bounds());
		}
		kin=0;
	}
}

void logipview::KeyUp(const char *bytes,int32 numBytes)
{
	if(numBytes==1){
		if((*bytes=='8')||(*bytes==B_UP_ARROW))know&=0xfe;
		if((*bytes=='2')||(*bytes==B_DOWN_ARROW))know&=0xfd;
		if((*bytes=='4')||(*bytes==B_LEFT_ARROW))know&=0xfb;
		if((*bytes=='6')||(*bytes==B_RIGHT_ARROW))know&=0xf7;
	}
}

void logipview::MessageReceived(BMessage *msg)
{
	switch(msg->what){
		case B_SIMPLE_DATA:{
			uint32	type;
			int32	files;
			msg->GetInfo("refs",&type,&files);
			for(int i=0;i<files;i++){
				entry_ref	eref;
				msg->FindRef("refs",i,&eref);
				df=new BFile(&eref,O_RDONLY|O_BINARY);
				BEntry	ent(&eref);
				struct stat	fst;
				delete db;	db=NULL;
				job=0;
				ent.GetStat(&fst);
				dbl=fst.st_size;
				db=new char[dbl];
				df->Read(db,dbl);
				delete df;
				titles=0;
				if(!strncmp(db,"logipdata",9)){
					titles=*(db+63);
					job=-1;
					ef=0;
					strcpy(fn,eref.name);
					rec.set_rec(fn,titles);
					break;
				}else{
					delete db;
					db=NULL;
					strcpy(fn,"");
				}
			}
			Invalidate();
		}break;
		/*case 'DATA':*/
		case 'MIME':{
			if(db[15]){
				char 	*s;
				long	bc;
				int		i;
				msg->FindData("text/plain",B_MIME_DATA,(void**)&s,&bc);
				if(job==1){
					if(bc>46)bc=46;
					memcpy(db+16,s,bc);
					memset(db+16+bc,0,47-bc);
					job=-1;
					Invalidate();
				}
				if((job==2)&&(ef)){
					if(bc>63)bc=63;
					memcpy(title,s,bc);
					memset(title+bc,0,64-bc);
				}
			}
		}break;
		case B_SAVE_REQUESTED:{		//save
			entry_ref	dir;
			char		*name;
			msg->FindRef("directory",&dir);
			msg->FindString("name",&name);
			df=new BFile();
			BDirectory(&dir).CreateFile(name,df,false);
			df->Write(db,dbl);
			delete df;
			fp=NULL;
		}break;
		case B_CANCEL:{				//save cansel
			fp=NULL;
		}break;
		case 'fiop':{
			if(fp==NULL){
				fp=new BFilePanel(B_OPEN_PANEL,NULL,NULL,B_FILE_NODE,false);
				fp->Show();
			}
		}break;
		case 'ficl':{
			allclear();
		}break;
		case 'fisa':{				//save(wrk)
			if((!ef)&&(job==2)){
				wrk.set_wrk(fn,no,bd);
			}
		}break;
		case 'fine':{
			allclear();
			strcpy(title,"no name");
			dbl=64;
			db=new char[dbl];
			memset(db,0,dbl);
			strcpy(db,"logipdata");
			*(db+15)=1;			//editable
			titles=no=0;
			add_dat();
			ef=1;
			gamestart();
		}break;
		case 'finw':{
			if((job==1)&&(db[15])&&(db)&&(fp==NULL)){
				fp=new BFilePanel(B_SAVE_PANEL,NULL,NULL,B_FILE_NODE,false);
				fp->Show();
			}
		}break;
		case 'fise':{
			if(job>1){
				if((ef)&&(job==2)&&(db[15]))ren_dat();
				ef=0;
				no=-1;
				job=-1;
				Invalidate();
			}
		}break;
		case 'edpl':{
			if(job==2){
				if((ef)&&(db[15]))ren_dat();
				ef=0;
				gamestart();
			}
		}break;
		case 'edep':{
			if((job==2)&&(db[15])){
				if(ef==0){ef=1;gamestart();}else{ef=1;}
			}
		}break;
		case 'edad':{
			if((job>0)&&(db[15])){
				if((ef)&&(job==2))ren_dat();
				no=titles;
				add_dat();
				ef=1;
				gamestart();
			}
		}break;
		case 'edde':{
			if((job==2)&&(db[15])){
				del_dat();
				ef=0;
				no=-1;
				job=-1;
				Invalidate();
			}
		}break;
		case 'socl':{
			if(job==2){
				bd->clr_mat((ef==1)?0:2);
				bd->chk_ans();
				bm->redraw_box(-1,-1);
				bm->redraw_hints(-1,-1);
				Invalidate();
			}
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void logipview::redraw()
{
	DrawBitmap(bm,Bounds(),Bounds());
}

void logipview::allclear()
{
	delete	db;	db=NULL;
	delete	bm;	bm=NULL;
	delete	bd;	bd=NULL;
	no=-1;
	titles=0;
	job=0;
	Invalidate();
}

void logipview::gamestart()
{
	char	*p;
	p=db+64;
	for(int i=0;i<no;i++)p+=(*p)*256+*((uchar*)p+1);
	p+=2;
	strcpy(title,p);
	p+=strlen(title)+1;
	width=*(p++);	height=*(p++);
	delete	bd;
	bd=new logipboard(width,height);
	if(ef){
		bd->set_ans((uchar*)p);
		bd->set_hnt(false);
		bd->chk_ans();
	}else{
		bd->set_ans((uchar*)p);
		bd->set_hnt();
		bd->clr_mat();
		wrk.get_wrk(fn,no,bd);
		bd->chk_ans();
	}
	delete	bm;
	bm=new logipbitmap(bd);
	ResizeTo(bm->Bounds().Width(),bm->Bounds().Height());
	Window()->SetSizeLimits(50,bm->Bounds().Width(),50,bm->Bounds().Height()+20);
	Window()->ResizeTo(bm->Bounds().Width(),bm->Bounds().Height()+20);
	job=2;
	Invalidate();
}

void logipview::gameend()
{
	job=3;
	tm=bm->Bounds().Width();
	rec.set_rec(fn,titles,no,'o');
	wrk.set_wrk(fn,no);
}

void logipview::add_dat()
{
	char	*p=db+64;
	for(no=0;no<titles;no++)p+=(*p)*256+*((uchar*)p+1);
	dbl=p-db;
	strcpy(title,"no name");
	int		l=2+strlen(title)+1+2+(ed_w*ed_h+7)/8;
	int		n_bufl=dbl+l+2;
	char	*n_buf=new char[n_bufl];
	memset(n_buf,0,n_bufl);
	memcpy(n_buf,db,dbl);
	delete	db;
	db=n_buf;
	p=db+dbl;
	dbl=n_bufl;
	db[63]=++titles;
	*(p++)=l/256;		*(p++)=l%256;
	strcpy(p,title);	p+=strlen(title);
	*(++p)=ed_w;		*(++p)=ed_h;
}

void logipview::del_dat()
{
	char	*p,*q;
	p=q=db+64;
	for(int i=0;i<titles;i++){
		int	l=(*q)*256+*((uchar*)q+1);
		if(p!=q)memcpy(p,q,l);
		if(i!=no)p+=l;
		q+=l;
	}
	db[63]=--titles;
	*((uint16*)p)=0;
	dbl=p+2-db;
}

void logipview::ren_dat()
{
	char	*p,*q;
	q=db+64;
	for(int i=0;i<no;i++)q+=(*q)*256+*((uchar*)q+1);
	int		l=2+strlen(title)+1+2+(width*height+7)/8;
	int		n_bufl=dbl-((*q)*256+*(q+1))+l+2;
	char	*n_buf=new char[n_bufl];
	memset(n_buf,0,n_bufl);
	memcpy(n_buf,db,q-db);
	p=n_buf+(q-db);
	*(p++)=l/256;		*(p++)=l%256;
	strcpy(p,title);	p+=strlen(title);
	*(++p)=width;
	*(++p)=height;
	bd->to_buf((uchar*)++p);
	p+=(width*height+7)/8;
	q+=(*q)*256+*(q+1);
	for(int i=no+1;i<titles;i++){
		int	l=(*q)*256+*(q+1);
		memcpy(p,q,l);
		p+=l;
		q+=l;
	}
	delete	db;
	db=n_buf;
	dbl=p+2-db;
}
//------------------------------------------------
logiprec::logiprec()
{
	BEntry		ent("/boot/home/config/settings/Beer/logip.rec");
	struct stat	fst;
	ent.GetStat(&fst);
	BFile		rf(&ent,O_RDONLY);
	if(rf.IsReadable()){
		rbl=fst.st_size;
		rb=new char[rbl+1];
		rf.Read(rb,rbl);
		rb[rbl]=0;
	}else{
		rb=new char[1];
		*rb=0;
		rbl=0;
	}
}

logiprec::~logiprec()
{
	delete	rb;
}

void logiprec::write_rec()
{
	BDirectory	rd("/boot/home/config/settings");
	rd.CreateDirectory("Beer",&rd);
	rd.SetTo("/boot/home/config/settings/Beer");
	BFile		rf;
	rd.CreateFile("logip.rec",&rf,false);
	if(rf.IsWritable())rf.Write(rb,rbl);
}

void logiprec::set_rec(char *fn,int fl,int no,char f)
{
	int		nbl=rbl+strlen(fn)+fl+3;
	char	*nb=new char[nbl];
	char	*p,*q;
	char	s[256];
	sprintf(s,"\"%s\"",fn);
	p=strstr(rb,s);
	memset(s,0,256);
	int		i=0;
	if(p){
		q=strchr(p,',')+1;
		for(i=0;(i<fl)&&(q[i]!='\n');i++){
			s[i]=q[i];
		}
	}
	memset(s+i,'-',fl-i);
	if(no>=0)s[no]=f;
	if(p){
		memcpy(nb,rb,p-rb);		q=nb+(p-rb);
		q+=sprintf(q,"\"%s\",%s\n",fn,s);
		p=strchr(p,'\n')+1;
		memcpy(q,p,rb+rbl-p);	q=q+(rb+rbl-p);
	}else{
		memcpy(nb,rb,rbl);		q=nb+rbl;
		q+=sprintf(q,"\"%s\",%s\n",fn,s);
	}
	*q=0;
	delete	rb;
	rb=nb;	rbl=q-rb;
}

char logiprec::get_rec(char *fn,int no)
{
	char	f='-';
	char	*p,*q;
	char	s[256];
	sprintf(s,"\"%s\"",fn);
	p=strstr(rb,s);
	if(p){
		p=strchr(p,',')+1;
		q=strchr(p,'\n');
		if(q-p>no)f=p[no];
	}
	return(f);
}

logipwrk::logipwrk()
{
	BEntry		ent("/boot/home/config/settings/Beer/logip.wrk");
	struct stat	fst;
	ent.GetStat(&fst);
	BFile		wf(&ent,O_RDONLY|O_BINARY);
	if(wf.IsReadable()){
		wbl=fst.st_size;
		wb=new char[wbl];
		wf.Read(wb,wbl);
	}else{
		wb=new char[2];
		wb[0]=0;
		wbl=0;
	}
}

logipwrk::~logipwrk()
{
	delete	wb;
}

void logipwrk::write_wrk()
{
	BDirectory	wd("/boot/home/config/settings");
	wd.CreateDirectory("Beer",&wd);
	wd.SetTo("/boot/home/config/settings/Beer");
	BFile		wf;
	wd.CreateFile("logip.wrk",&wf,false);
	if(wf.IsWritable())wf.Write(wb,wbl);
}

void logipwrk::set_wrk(char *fn,int no,logipboard *bd)
{
	char	*p=wb;
	while(p<wb+wbl){
		int		l=(uchar)p[0]*256+(uchar)p[1];
		if((!strcmp(p+2,fn))&&(p[strlen(fn)+3]==no)){
			memcpy(p,p+l,wbl-(p+l-wb));
			wbl-=l;
			break;
		}
		p+=l;
	}
	if(bd){
		int		matl=bd->w*bd->h;
		int		l=2+strlen(fn)+1+1+2+matl;
		int		nbl=wbl+l;
		char	*nb=new char[nbl];
		p=nb;
		*(p++)=l>>8;	*(p++)=l;
		strcpy(p,fn);	p+=strlen(fn)+1;
		*(p++)=no;
		*(p++)=bd->w;	*(p++)=bd->h;
		memcpy(p,bd->mat,matl);
		p+=matl;
		memcpy(p,wb,wbl);
		delete	wb;
		wb=nb;	wbl=nbl;
	}
}

void logipwrk::get_wrk(char *fn,int no,logipboard *bd)
{
	char	*p=wb;
	while(p<wb+wbl){
		if((!strcmp(p+2,fn))&&(p[strlen(fn)+3]==no)){
			memcpy(bd->mat,p+strlen(fn)+6,bd->w*bd->h);
			break;
		}
		p+=(uchar)p[0]*256+(uchar)p[1];
	}
}
//------------------------------------------------
logipbitmap::logipbitmap(logipboard *board):BBitmap(BRect(0,0,(board->w+board->hc)*20,(board->h+board->vc)*20),B_RGB_32_BIT)
{
	bd=board;
	bw=BytesPerRow()/4;
	memset(Bits(),0,BitsLength());
	for(int i=-bd->hc;i<=bd->w;i++)vline((bd->hc+i)*20,0,(bd->vc+bd->h)*20,(i%5)?c_frm_g:c_frm_r);
	for(int i=-bd->vc;i<=bd->h;i++)hline(0,(bd->vc+i)*20,(bd->hc+bd->w)*20,(i%5)?c_frm_g:c_frm_r);
	for(int y=0;y<bd->h;y++)for(int x=0;x<bd->w;x++)redraw_box(x,y);
	for(int x=0;x<bd->w;x++)redraw_hints(x,-1);
	for(int y=0;y<bd->h;y++)redraw_hints(-1,y);
}

void logipbitmap::redraw_box(int x,int y)
{
	int	xs,xe,ys,ye;
	if(x<0){xs=0;xe=bd->w-1;}else{xs=x;xe=x;}
	if(y<0){ys=0;ye=bd->h-1;}else{ys=y;ye=y;}
	for(int yy=ys;yy<=ye;yy++)for(int xx=xs;xx<=xe;xx++){
		uint32	c=c_box_g;
		if(bd->mat[bd->w*yy+xx]==0)c=c_box_w;
		if(bd->mat[bd->w*yy+xx]==1)c=c_box_b;
		fillbox((bd->hc+xx)*20+1,(bd->vc+yy)*20+1,19,c);
	}
}

void logipbitmap::redraw_hints(int x,int y)
{
	uint32	fc,bc;
	fc=c_hnt_f;
	if(x>=0){
		bc=(bd->ok[x])?c_hnt_o:c_hnt_n;
		for(int i=0;i<bd->vc;i++)drawnum((bd->hc+x)*20+1,(bd->vc-i-1)*20+1,19,bd->hint[x*(bd->h+1)/2+i],fc,bc);
	}
	if(y>=0){
		bc=(bd->ok[bd->w+y])?c_hnt_o:c_hnt_n;
		for(int i=0;i<bd->hc;i++)drawnum((bd->hc-i-1)*20+1,(bd->vc+y)*20+1,19,bd->hint[bd->w*(bd->h+1)/2+y*(bd->w+1)/2+i],fc,bc);
	}
}

char logipbitmap::bm_to_mat(int &x,int &y)
{
	char	f=0;
	x-=bd->hc*20;
	y-=bd->vc*20;
	x=(x>=0)?x/20:x/20-1;
	y=(y>=0)?y/20:y/20-1;
	if((x>=0)&&(x<bd->w)&&(y>=0)&&(y<bd->h))f=1;
	if((x>=0)&&(x<bd->w)&&(y>=-bd->vc)&&(y<0))f=-1;
	if((x>=-bd->hc)&&(x<0)&&(y>=0)&&(y<bd->h))f=-2;
	return(f);
}

void logipbitmap::vline(int x,int y,int l,uint32 c)
{
	uint32	*p=(uint32*)Bits()+bw*y+x;
	while(l--){
		*p=c;
		p+=bw;
	}
}

void logipbitmap::hline(int x,int y,int l,uint32 c)
{
	uint32	*p=(uint32*)Bits()+bw*y+x;
	while(l--)*(p++)=c;
}

void logipbitmap::fillbox(int x,int y,int s,uint32 c)
{
	uint32	*p=(uint32*)Bits()+bw*y+x;
	int		h=s;
	while(h--){
		int		w=s;
		while(w--)*(p++)=c;
		p+=bw-s;
	}
}

void logipbitmap::drawnum(int x,int y,int s,uchar n,uint32 fc,uint32 bc)
{
	uint32	*p=(uint32*)Bits()+bw*y+x;
	int		ox=(s-16)/2;
	int		oy=(s-12)/2;
	for(int yy=0;yy<s;yy++){
		uint16	d=0;
		if((yy>=oy)&&(yy<oy+12)){
			if(n>9)d=((uint16)numbm[n/10][yy-oy])<<8;
			if(n>0)d|=numbm[n%10][yy-oy];
		}
		for(int xx=0;xx<s;xx++){
			bool	f=((xx>=ox)&&(xx<ox+16))?d&(1<<(16-xx)):false;
			*(p++)=f?fc:bc;
		}
		p+=bw-s;
	}
}

logipboard::logipboard(uchar width,uchar height)
{
	w=width;	h=height;
	vc=hc=0;
	mat=new uchar[w*h];						memset(mat,2,w*h);
	hint=new uchar[w*(h+1)/2+h*(w+1)/2];	memset(hint,0,w*(h+1)/2+h*(w+1)/2);
	ok=new uchar[w+h];						memset(ok,0,w+h);
}

logipboard::~logipboard()
{
	delete	mat;
	delete	hint;
	delete	ok;
}

void logipboard::resize(uchar width,uchar height)
{
	uchar	*n_mat=new uchar[width*height];
	memset(n_mat,0,width*height);		//white
	int	cp_w=(width<w)?width:w;
	int	cp_h=(height<h)?height:h;
	for(int y=0;y<cp_h;y++)for(int x=0;x<cp_w;x++)n_mat[width*y+x]=mat[w*y+x];
	delete	mat;
	mat=n_mat;	w=width;	h=height;
	delete	hint;
	delete	ok;
	hint=new uchar[w*(h+1)/2+h*(w+1)/2];	set_hnt(false);
	ok=new uchar[w+h];						memset(ok,0,w+h);
}

void logipboard::set_ans(uchar *ans)
{
	char	b=0;
	int		p=0;
	uchar	d;
	for(int y=0;y<h;y++)for(int x=0;x<w;x++){
		if(b==0){
			d=*(ans++);
			b=8;
		}
		mat[p++]=(d&1)?1:0;
		d>>=1;
		b--;
	}
}

void logipboard::set_hnt(bool f)
{
	memset(hint,0,w*(h+1)/2+h*(w+1)/2);
	for(int x=0;x<w;x++){
		int	cc=0;
		int	p=x*(h+1)/2;
		for(int y=h-1;y>=0;y--){
			int	d=mat[w*y+x];
			if(d==1)hint[p]++;
			if((hint[p]>0)&&(d==0)){p++;cc++;}
		}
		if(hint[p])cc++;
		if(cc>vc)vc=cc;
	}
	for(int y=0;y<h;y++){
		int	cc=0;
		int	p=w*(h+1)/2+y*(w+1)/2;
		for(int x=w-1;x>=0;x--){
			int	d=mat[w*y+x];
			if(d==1)hint[p]++;
			if((hint[p]>0)&&(d==0)){p++;cc++;}
		}
		if(hint[p])cc++;
		if(cc>hc)hc=cc;
	}
	if(!f){
		vc=(h+1)/2;
		hc=(w+1)/2;
	}
}

void logipboard::clr_mat(uchar c)
{
	memset(mat,c,w*h);
	memset(ok,0,w+h);
}

bool logipboard::chk_ans()
{
	bool	f,ff;
	int		p,q,c;
	ff=true;
	uchar	*ck=new uchar[128];
	q=0;
	for(int x=0;x<w;x++){
		memset(ck,0,128);
		p=0;
		f=true;
		for(int y=h-1;y>=0;y--){
			int	d=mat[w*y+x];
			if(d>1)f=false;
			if(d==1)ck[p]++;
			if((ck[p]>0)&&(d==0))p++;
		}
		f&=!strncmp((char*)&(hint[x*(h+1)/2]),(char*)ck,(h+1)/2);
		ff&=f;
		ok[q++]=f?1:0;
	}
	for(int y=0;y<h;y++){
		memset(ck,0,128);
		p=0;
		f=true;
		for(int x=w-1;x>=0;x--){
			int	d=mat[w*y+x];
			if(d>1)f=false;
			if(d==1)ck[p]++;
			if((ck[p]>0)&&(d==0))p++;
		}
		f&=!strncmp((char*)&(hint[w*(h+1)/2+y*(w+1)/2]),(char*)ck,(w+1)/2);
		ff&=f;
		ok[q++]=f?1:0;
	}
	delete	ck;
	return(ff);
}

void logipboard::change_box(int x,int y,int z)
{
	if((x<0)||(x>=w)||(y<0)||(y>=h))return;
	if(z==-1){
		z=mat[w*y+x];
		z=(z+1)%3;
	}
	if(z==-2)z=(mat[w*y+x]==0)?1:0;
	mat[w*y+x]=z;
}

void logipboard::change_hint(int x,int y,int z)
{
	int	p;
	if(y<0){
		if((x<0)||(y<-vc))return;
		p=x*(h+1)/2-y-1;
		if(z==-1)z=(hint[p]+1)%(h+1);
		if(z==-2)z=(hint[p]+h)%(h+1);
		hint[p]=z;
	}
	if(x<0){
		if((y<0)||(x<-hc))return;
		p=w*(h+1)/2+y*(w+1)/2-x-1;
		if(z==-1)z=(hint[p]+1)%(w+1);
		if(z==-2)z=(hint[p]+w)%(w+1);
		hint[p]=z;
	}
}

void logipboard::to_buf(uchar *ans)
{
	int		p=0;
	uchar	b=0x01;
	uchar	d=0;
	for(int y=0;y<h;y++)for(int x=0;x<w;x++){
		if(mat[p++])d|=b;
		if(b==0x80){
			*(ans++)=d;
			d=0;
			b=0x01;
		}else{
			b<<=1;
		}
	}
	if(b!=0x01)*ans=d;
}
