// logip.h

#include	<Be.h>


class logipboard
{
	public:
		logipboard(uchar width,uchar height);
		~logipboard();
		void	resize(uchar width,uchar height);
		void	set_ans(uchar *ans);	// set answer & create hints
		void	set_hnt(bool f=true);	// set hints
		void	clr_mat(uchar c=2);		// clear matrix
		bool	chk_ans();				// check matrix=hints
		void	change_box(int x,int y,int z=-1);	//-1..3toggle  -2..2toggle
		void	change_hint(int x,int y,int z=-1);	//>=0..set  -1..inc  -2..dec
		void	to_buf(uchar *ans);		// editdata to buffer
		uchar	w,h;	//matrix
		uchar	vc,hc;	//count of hints
		uchar	*mat;	//size=w*h
		uchar	*hint;	//size=w*(h+1)/2+h*(w+1)/2
		uchar	*ok;	//size=w+h
};

class logipbitmap:public BBitmap
{
	public:
		logipbitmap(logipboard *board);
		void	redraw_box(int x,int y);
		void	redraw_hints(int x,int y);
		char	bm_to_mat(int &x,int &y);
	private:
		void	vline(int x,int y,int l,uint32 c);
		void	hline(int x,int y,int l,uint32 c);
		void	fillbox(int x,int y,int s,uint32 c);
		void	drawnum(int x,int y,int s,uchar n,uint32 fc,uint32 bc);
		logipboard	*bd;
		int			bw;		//BytesPerRow()/4
};

class logiprec
{
	public:
		logiprec();
		~logiprec();
		void	write_rec();
		void	set_rec(char *fn,int fl,int no=-1,char f=0);
		char	get_rec(char *fn,int no);
	private:
		char	*rb;
		int		rbl;
};

class logipwrk
{
	public:
		logipwrk();
		~logipwrk();
		void	write_wrk();
		void	set_wrk(char *fn,int no,logipboard *bd=NULL);
		void	get_wrk(char *fn,int no,logipboard *bd);
	private:
		char	*wb;
		int		wbl;
};

class logipview:public BView
{
	public:
		logipview(BRect frame);
		~logipview();
		void	AttachedToWindow();
		void	Draw(BRect rect);
		void	Pulse();
		void	MouseDown(BPoint pt);
		void	MouseMoved(BPoint pt,uint32 code,const BMessage *msg);
		void	KeyDown(const char *bytes,int32 numBytes);
		void	KeyUp(const char *bytes,int32 numBytes);
		void	MessageReceived(BMessage *msg);
		void	redraw();
		void	allclear();
		void	gamestart();
		void	gameend();
		void	add_dat();
		void	del_dat();
		void	ren_dat();
		void	read_rec();
		void	write_rec();
	private:
		BFilePanel	*fp;
		BFile		*df;
		char		*db;
		int			dbl;
		int			titles;
		int			no;
		char		title[64];
		uchar		width,height;
		logipboard	*bd;
		logipbitmap	*bm;
		char		job;	//0..no_data  1..select_no  2..play  3..complete
		int			tm;
		char		ef;
		int8		ed_w,ed_h;
		uchar		kin,know;
		logiprec	rec;
		char		fn[32];
		logipwrk	wrk;
};

class logipwindow:public BWindow
{
	public:
		logipwindow(BRect frame);
		bool	QuitRequested();
		void	setupmenus();
		logipview	*v;
};

class logip:public BApplication
{
	public:
		logip();
		void	RefsReceived(BMessage *mes);
		void	MessageReceived(BMessage *mes);
		void	AboutRequested();
		logipwindow	*w;
};
